//camera interface
//Version 2.0

#ifndef _CAMERA_H_
#define _CAMERA_H_

#include <d3d9.h>
#include <d3dx9.h>
#include <math.h>

class Camera 
{
public:

	////////////////////////////
	//camera class constructor
	////////////////////////////
	Camera();

	//////////////
	//destructor
	//////////////
	~Camera();

	//////////////////////////////
	//Camera accessor functions
	/////////////////////////////
	inline const D3DXMATRIX& GetView() const {return mView;}
	inline const D3DXMATRIX& GetProj() const {return mProj;}
	inline D3DXMATRIX& GetVP() {return mVP;}
	
	inline const D3DXVECTOR3& GetRight() const {return mRight;}
	inline const D3DXVECTOR3& GetUp() const {return mUp;}
	inline  D3DXVECTOR3 GetLook()  {return mLook;}

	inline D3DXVECTOR3& RWPosition() {return mPos;}

	/////////////////////////
	//Camera functionality
	/////////////////////////
	void SetPerspective(float fov, float aspect, float nearZ, float farZ);
	void SetSpeed(float speed);
	void BuildView();
	void Update(float dTime);

private:
	D3DXMATRIX mView;
	D3DXMATRIX mProj;
	D3DXMATRIX mVP;

	D3DXVECTOR3 mPos;
	D3DXVECTOR3 mRight;
	D3DXVECTOR3 mUp;
	D3DXVECTOR3 mLook;

	float mSpeed;
};

//extern me
extern Camera* gCamera;

#endif