//Game winodw interface (inherited from the D3DWindow class)

#ifndef _GAME_H_
#define _GAME_H_

#include "input.h"
#include "d3dwindow.h"
#include "timer.h"
#include "scene.h"

class TestApp : public D3DWindow
{
public:
	//constructor
	TestApp(HINSTANCE hInstance, std::string winCaption, D3DDEVTYPE devType, DWORD requestedVP);

	//destructor
	~TestApp();

	//app managment functions (overloaded from the D3DWindow class)
	bool checkDeviceCaps();
	void onLostDevice();
	void onResetDevice();
	void Update(float fTime);
	void Draw();

	//additional functions 3D projection
	void BuildViewMatrix();
	void BuildProjMatrix();

private:
	//font belongs only to this app window
	ID3DXFont* mFont;

	//mesh/camera transformation variables
	D3DXVECTOR3 mCamVec;
	D3DXVECTOR3 mCamPos;

	//View & projection matrix data members
	D3DXMATRIX mView;
	D3DXMATRIX mProj;
};

//extern me
extern Input* gGameInput; 
extern Timer* gTimer;

#endif