//DirectInput interface for the game application

#ifndef _GAME_INPUT_H_
#define _GAME_INPUT_H_

#define DIRECTINPUT_VERSION 0x0800

#include <dinput.h>
#include "d3dwindow.h"

class Input
{
public:
	//Input class constructor
	Input(HWND gameWindow);

	//Input class destructor
	virtual ~Input();

	void UpdateInput();

	//Mouse and keyboard input functions
	bool GetKeyPress(char key, bool ignorePressStamp = false);
	bool GetButtonPress(char button, bool ignorePressStamp = false);

	long GetMousePosX();
	long GetMousePosY();
	long GetMouseDeltaX();
	long GetMouseDeltaY();
	long GetMouseWheel();

private:
	HWND m_inputWindow;
	IDirectInput8 *m_diObj; 
	unsigned long m_pressStamp; 

	IDirectInputDevice8 *m_keyboard; 
	char m_keyState[256]; 
	unsigned long m_keyPressStamp[256]; 

	IDirectInputDevice8 *m_mouse; 
	DIMOUSESTATE m_mouseState; 
	unsigned long m_buttonPressStamp[3]; 
	POINT m_position; 

};

#endif