//Water plane rendering interface
//Written by Vladeta Stojanovic (0602920@live.abertay.ac.uk)
//Based on he code written by Frank D. Luna

#ifndef _WATER_H_
#define _WATER_H_

#include "scene.h"

#define EPSILON 0.001f

class Water
{
public:
	
	Water(WaterInitInfo& initInfo);

	~Water();

	void OnLostDevice();
	void OnResetDevice();

	void buildFX();

	void GenerateGrid(int numVertRows, int numVertCols, 
					  float dx, float dz, const D3DXVECTOR3& center, 
					  std::vector<D3DXVECTOR3>& verts, std::vector<DWORD>& indices);

	void update(float dt);
	void draw(D3DXMATRIX pMatrix, D3DXVECTOR3 CamPos);

	void setEnvMap(IDirect3DCubeTexture9* envMap);

private:

	ID3DXMesh* mMesh;
	ID3DXEffect* mWaterFX;

	//Wave texture normal maps
	IDirect3DTexture9* mWaveMap0;
	IDirect3DTexture9* mWaveMap1;

	//Offset for nomral map scrolling
	D3DXVECTOR2 mWaveMapOffset0;
	D3DXVECTOR2 mWaveMapOffset1;

	WaterInitInfo mInitInfo;
	float mWidth;
	float mDepth;

	D3DXHANDLE mhTech;
	D3DXHANDLE mhWVP;
	D3DXHANDLE mhWorld;
	D3DXHANDLE mhWorldInv;
	D3DXHANDLE mhLight;
	D3DXHANDLE mhMtrl;
	D3DXHANDLE mhEyePosW;
	D3DXHANDLE mhWaveMap0;
	D3DXHANDLE mhWaveMap1;
	D3DXHANDLE mhWaveMapOffset0;
	D3DXHANDLE mhWaveMapOffset1;
	D3DXHANDLE mhEnvMap;
};

//extern me
extern Water* gWater;

#endif